package jwars.data;

import java.util.Scanner;

import jwars.event.EventQueue;
import jwars.model.WarModel;
import jwars.model.weapons.Weapon;
import jwars.model.weapons.ShellType;
import jwars.model.weapons.Shell;
import jwars.test.explosions.ImpactAnimationType;

public class WeaponCategory extends Category<Weapon> {

  public final static String CATEGORY_NAME = "weapon";
  public final String name;
  public final double range;
  public final double effectiveRange;
  //public final double reloadTime;
  public final int reloadTime;
  public final ShellType type;
  public final ImpactAnimationType explosionType;
  public final double splashRange;
  public final double baseSteelPenetration;
  public final double killValue;

  //private final EventQueue reloadQueue;

  public WeaponCategory(Loader loader, Scanner input){
    super(input);
    name = Syntax.readNameRemoveQuotationMarks(input);
    range = loader.readNumber(input);
    effectiveRange = loader.readNumber(input);
    reloadTime = WarModel.WORLD.secondsToFrames(loader.readNumber(input));
    //reloadQueue = new EventQueue(WarModel.WORLD.secondsToFrames(reloadTime));
    String shellType = input.next();
    type = ShellType.valueOf(shellType);
    if(type == ShellType.bullet){
      baseSteelPenetration = 0;
    } else {
      baseSteelPenetration = Double.valueOf(input.next());
    }
    killValue = Double.valueOf(input.next());
    String explosionName = input.next();
    //System.out.println("exp type "+explosionName);
    //System.out.println("elems "+ImpactAnimationType.explosions.toString());
    explosionType = ImpactAnimationType.explosions.get(explosionName);
    splashRange = loader.readNumber(input);
    //WarModel.QUEUES.register(reloadQueue);
  }

  public String toString(){
    return name;
  }

  public Weapon create(){
    return new Weapon(this);
  }

}
