package jwars.gui;

import java.util.List;

import java.awt.BorderLayout;
import javax.swing.BorderFactory;
import javax.swing.DefaultListCellRenderer;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.JPanel;

import jwars.control.UnitSelectionListener;
import jwars.model.Formation;
import jwars.model.Moveable;
import jwars.model.Unit;

public class InfoPanel extends JPanel implements UnitSelectionListener {

  private JList list = new JList(new DefaultListModel());

  public InfoPanel(){
    super(new BorderLayout());
    list.setRequestFocusEnabled(false);
    list.setFocusable(false);
    list.setDragEnabled(false);
    list.setOpaque(false);
    ((DefaultListCellRenderer)list.getCellRenderer()).setOpaque(false);
    setBorder(BorderFactory.createTitledBorder(""));
    add(list, BorderLayout.CENTER);
    jwars.control.Control.UNIT_SELECTION.addListener(this);
  }

  public void unitSelected(Unit newSelection, Unit lastSelection){
    DefaultListModel model = (DefaultListModel)list.getModel();
    model.clear();
    if(newSelection == null){
      setBorder(BorderFactory.createTitledBorder(""));
      return;
    }
    String name = newSelection.toString();
    setBorder(BorderFactory.createTitledBorder(name));
    List objects;
    if (newSelection instanceof Moveable){
      Moveable m = (Moveable)newSelection;
      objects = m.getWeaponModel().getWeaponList();
    } else if (newSelection instanceof Formation){
      Formation f = (Formation)newSelection;
      objects = f.getSubUnitList();
    } else {
      objects = new java.util.ArrayList<String>(); //Not reached
    }
    for(Object o : objects){
      model.addElement(o.toString());
    }
    //repaint();
  }
}
