package jwars.model;

import java.util.ArrayList;
import java.util.List;

public class DefaultFormationPositions{

  private final static List<DecimalCoord> coords = new ArrayList<DecimalCoord>();
  static{
    add(0,0);
    add(1,2);
    add(1,-2);
    add(2,0);
    add(0,4);
    add(0,-4);
    add(-1,2);
    add(-1,-2);
    add(-2, 0);
    //add(-2, 4);
    //add(-2, -4);
  }

  public static double rotateX(double x, double y, double theta){
    return x*Math.cos(theta) - y*Math.sin(theta);
  }

  public static double rotateY(double x, double y, double theta){
    return y*Math.cos(theta) + x*Math.sin(theta);
  }

  public static double getX(int index, double angle, double scale){
    DecimalCoord c = coords.get(index);
    return rotateX(c.x, c.y, angle) * scale;
  }

  public static double getY(int index, double angle, double scale){
    DecimalCoord c = coords.get(index);
    return rotateY(c.x, c.y, angle) * scale;
  }


  private static void add(double x, double y){
    coords.add(new DecimalCoord(x,y));
  }

  private static class DecimalCoord{

    public final double x, y;

    public DecimalCoord(double x, double y){
      this.x = x;
      this.y = y;
    }

  }

}
