package jwars.model.map;

public class Coordinate{

  CoordinateSystem system;
  int x, y;

  public Coordinate(CoordinateSystem system, int x, int y){
    set(system,x,y);
  }

  public Coordinate(Coordinate coord){
    set(coord);
  }

  public Coordinate set(CoordinateSystem system, int x, int y){
    this.system = system;
    this.x = x;
    this.y = y;
    return this;
  }

  public Coordinate set(Coordinate coord){
    return set(coord.system, coord.x, coord.y);
  }

  public Coordinate transformTo(CoordinateSystem system){
    x = x * this.system.scale / system.scale;
    y = y * this.system.scale / system.scale;
    this.system = system;
    return this;
  }

  public CoordinateSystem getCoordinateSystem(){
    return system;
  }

  public int getX(){
    return x;
  }

  public int getY(){
    return y;
  }

}
