package jwars.model.map;

public class Transform{

  private CoordinateSystem src, dst;

  public Transform(CoordinateSystem src, CoordinateSystem dst){
    this.src = src;
    this.dst = dst;
  }

  public int convert(int x){
    return src.transformToCoords(dst, x);
  }

  public int[] convert(int[] values){
    return src.transformToCoords(dst, values);
  }

  public int[] convert(int[] values, int offset, int len){
    return src.transformToCoords(dst, values, offset, len);
  }

  public Transform inverse(){
    return new Transform(dst, src);
  }

}
