package jwars.model.structures;

import jwars.gui.units.Sprite;
import jwars.model.collision.Collider;
import jwars.model.collision.CollisionProperties;
import jwars.model.Coord;
import java.awt.Graphics2D;
import jwars.model.WarModel;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;

public class TerrainObject
    implements Collider{

  private Image image;

  private Coord[] structPoints;
  private Coord location = new Coord();
  private TerrainSprite sprite;
  private CollisionProperties collisionProps;
  private int radius;
  private double angle;
  public boolean small;

  public TerrainObject(Image image, BluePrint bluePrint, double angle, int x,
                       int y){

    this.angle = angle;
    this.image = image;
    this.radius = bluePrint.getRadius();
    if(radius < 500){
      small = true;
    }
    else small = false;

    this.location.set(x, y);

    radius = 0;
    collisionProps = new CollisionProperties(this, bluePrint.getMassive(),
        bluePrint.getMoveable());

    for(Coord c : structPoints = bluePrint.createStructure()){
      c.rotate(angle).plus(location);
    }

    sprite = new TerrainSprite(getRadius());
  }

  public CollisionProperties getCollisionProps(){
    return collisionProps;
  }

  public int getX(){
    return location.x;
  }

  public int getY(){
    return location.y;
  }

  public int getRadius(){
    return radius;
  }

  public Sprite getSprite(){
    return sprite;
  }

  public void collisionDetected(Collider other){
  }

  private class TerrainSprite
      extends Sprite{

    public TerrainSprite(int radius){
      super(radius);

      /*   xPoints = new int[structPoints.length];
         yPoints = new int[structPoints.length];
         for(int i = 0; i < structPoints.length; i++){
           xPoints[i] = structPoints[i].x - location.x;
           yPoints[i] = structPoints[i].y - location.y;
         }
         WarModel.WORLD.MAIN_COORDS.transformToCoords(WarModel.PIXEL_COORDS,
             xPoints);
         WarModel.WORLD.MAIN_COORDS.transformToCoords(WarModel.PIXEL_COORDS,
             yPoints);*/
    }

    public void draw(Graphics2D g2d, int x, int y){
      g2d.rotate(angle, x, y);
      g2d.drawImage(image, x, y, null);
    }

  }
}
