package jwars.model.units;

import jwars.Util;
import jwars.data.TankCategory;

public class Tank extends Vehicle {

  public final TankCategory CAT;
  private double turretAngle;

  public Tank(TankCategory cat){
    super(cat, cat.hull, cat.turret);
    CAT = cat;
  }

  public double getTurretAngle(){
    return turretAngle;
  }

  public boolean aimTowards(double theta){
    double angleDiff = Util.minusPiToPi(theta - this.theta - this.turretAngle);
    dirtify();
    double maxRotation = CAT.turret.traverseSpeed * dt;
    if(maxRotation > Math.abs(angleDiff)){
      //System.out.println("rotating complete ");
      this.turretAngle = theta - this.theta;
      return true;
    } else {
      //System.out.println("rotating...");
      this.turretAngle += maxRotation * Math.signum(angleDiff);
      return false;
    }
  }

}
