package jwars.model.units;

import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;

import java.awt.Color;

import jwars.Util;
import jwars.data.UnitCategory;
import jwars.model.Formation;
import jwars.data.FormationCategory;
import jwars.model.World;

public class Teams{

  public final static Team GERMANY = new Team("Germany", "GE", "German", "German", Util.readImage("ge_flag.png"), Color.blue);
  public final static Team SOVIET_UNION = new Team("Soviet Union", "SO", "Soviet", "Soviet", Util.readImage("so_flag.png"), Color.red);

  //Teams now have indices according to their position in this list
  private final static List<Team> TEAMS = new ArrayList<Team>();
  static {
    GERMANY.setOpponent(SOVIET_UNION);
    SOVIET_UNION.setOpponent(GERMANY);
    TEAMS.add(GERMANY);
    TEAMS.add(SOVIET_UNION);
  }

  public Teams(World world, Hashtable<String, UnitCategory> table){
    int worldChunkX = world.relativeToAbsoluteX(0.3);
    int worldChunkY = world.relativeToAbsoluteY(0.3);

    int germanPositionX = worldChunkX;//world.metric(300);
    int germanPositionY = world.MAIN_COORDS.HEIGHT - worldChunkY;//world.MAIN_COORDS.HEIGHT - world.metric(300);

    int sovietPositionX = world.MAIN_COORDS.WIDTH - worldChunkX;//world.MAIN_COORDS.WIDTH - world.metric(300);
    int sovietPositionY = worldChunkY;//world.metric(300);

    //ugly hack, replace with something safe
    UnitCategory catGe = table.get("ge_mixedbatt");
    UnitCategory catSo = table.get("so_mixedbatt");

    for(int i = 0; i < 2; i++){
      GERMANY.addUnit(catGe.create());
      SOVIET_UNION.addUnit(catSo.create());
    }

    ((Formation)SOVIET_UNION).setAngle(Math.PI-0.2);
    ((Formation)GERMANY).setAngle(-0.2);

    /*GERMANY.addUnit(createMixedBattallion());
    GERMANY.addUnit(createMixedBattallion());
    GERMANY.addUnit(createMixedBattallion());
    GERMANY.addUnit(createMixedBattallion());
    GERMANY.addUnit(createMixedBattallion());
    GERMANY.addUnit(createMixedBattallion());
    SOVIET_UNION.addUnit(createMixedBattallion());
    SOVIET_UNION.addUnit(createMixedBattallion());
    SOVIET_UNION.addUnit(createMixedBattallion());
    SOVIET_UNION.addUnit(createMixedBattallion());
    SOVIET_UNION.addUnit(createMixedBattallion());
    SOVIET_UNION.addUnit(createMixedBattallion());*/

    world.addTopLevelUnit(GERMANY);
    world.addTopLevelUnit(SOVIET_UNION);

    GERMANY.addToWorld(germanPositionX, germanPositionY, true);
    SOVIET_UNION.addToWorld(sovietPositionX, sovietPositionY, true);
  }

  public static Team getTeam(int teamIndex){
    return TEAMS.get(teamIndex);
  }

  public static int indexOf(Team team){
    return TEAMS.indexOf(team);
  }

  public static Team getTeamByShortName(String shortName){
    if(shortName.equals(GERMANY.NAME_SHORT)){
      return GERMANY;
    } else if(shortName.equals(SOVIET_UNION.NAME_SHORT)){
      return SOVIET_UNION;
    } else{
      throw new IllegalArgumentException("No such team: " + shortName);
    }
  }
  /*public Formation createMixedBattallion(){

    /*Formation f = new Formation("Battalion", world.metric(128));
    f.addUnit(createInfantryCompany());
    f.addUnit(createTankCompany());
    f.addUnit(createTankCompany());
    f.addUnit(createInfantryCompany());
    f.addUnit(createInfantryCompany());
    f.addUnit(createInfantryCompany());
    return f;
  }

  public Formation createInfantryPlatoon(){
    Formation f = new Formation("Rifle plt", world.metric(16));
    f.addUnit(new InfantrySquad());
    f.addUnit(new InfantrySquad());
    f.addUnit(new InfantrySquad());
    f.addUnit(new InfantrySquad());
    return f;
  }

  public Formation createTankPlatoon(){
    Formation f = new Formation("Tank plt", world.metric(24));
    f.addUnit(new Tank());
    f.addUnit(new Tank());
    f.addUnit(new Tank());
    return f;
  }

  public Formation createInfantryCompany(){
    Formation f = new Formation("Rifle co", world.metric(48));
    f.addUnit(createInfantryPlatoon());
    f.addUnit(createInfantryPlatoon());
    f.addUnit(createInfantryPlatoon());
    return f;
  }

  public Formation createTankCompany(){
    Formation f = new Formation("Tank co", world.metric(64));
    f.addUnit(createTankPlatoon());
    f.addUnit(createTankPlatoon());
    f.addUnit(createTankPlatoon());
    return f;
  }*/

}
