package jwars.net;

import java.io.DataInput;
import java.io.DataInputStream;
import java.io.DataOutput;
import java.io.DataOutputStream;
import java.io.IOException;

public interface ServerEventHandler{

  public void clientRemoved(int clientNumber, DataInputStream clientInput,
                            DataOutputStream clientOutput,
                            DataOutputStream commonOutput) throws IOException;

  public void clientJoined(int clientNumber, DataOutputStream commonOutput) throws IOException;

  /**
   * Return whether or not the connection is accepted
   * @param clientNumber int
   * @param clientInput DataInputStream
   * @param clientOutput DataOutputStream
   * @return boolean
   * @throws IOException
   */
  public boolean handShake(int clientNumber, DataInputStream clientInput,
                        DataOutputStream clientOutput) throws IOException;

  public void clientPropertyChanged(int clientNumber,
      DataInput clientInput,
      DataOutput commonOutput) throws IOException;


}
