package jwars.test;

public class Link<T>{

  Link<T> next, previous;
  T value;

  public Link(T value){
    this.value = value;
  }

  public Link(){}

  protected void remove(){
    previous.next = next;
    next.previous = previous;
    next = previous = null;
  }

  protected void insertAfter(Link<T> other){
    if(next != null || previous != null){
      throw new RuntimeException("Link cannot be enqueued, already linked");
    }
    this.previous = other;
    this.next = other.next;
    this.previous.next = this;
    this.next.previous = this;
  }

  protected void insertBefore(Link<T> other){
    insertAfter(other.previous);
  }

  protected void setValue(T value){
    this.value = value;
  }

  public T value(){
    return value;
  }

}
